<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Input StructType
 * @subpackage Structs
 */
class Input extends AbstractStructBase
{
    /**
     * The dongu
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InputDongu[]
     */
    public $dongu;
    /**
     * The dosyaAdi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dosyaAdi;
    /**
     * The gonderiTip
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $gonderiTip;
    /**
     * The gonderiTur
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $gonderiTur;
    /**
     * The kullanici
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kullanici;
    /**
     * The musteriId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $musteriId;
    /**
     * The sifre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sifre;
    /**
     * Constructor method for Input
     * @uses Input::setDongu()
     * @uses Input::setDosyaAdi()
     * @uses Input::setGonderiTip()
     * @uses Input::setGonderiTur()
     * @uses Input::setKullanici()
     * @uses Input::setMusteriId()
     * @uses Input::setSifre()
     * @param \StructType\InputDongu[] $dongu
     * @param string $dosyaAdi
     * @param string $gonderiTip
     * @param string $gonderiTur
     * @param string $kullanici
     * @param int $musteriId
     * @param string $sifre
     */
    public function __construct(array $dongu = array(), $dosyaAdi = null, $gonderiTip = null, $gonderiTur = null, $kullanici = null, $musteriId = null, $sifre = null)
    {
        $this
            ->setDongu($dongu)
            ->setDosyaAdi($dosyaAdi)
            ->setGonderiTip($gonderiTip)
            ->setGonderiTur($gonderiTur)
            ->setKullanici($kullanici)
            ->setMusteriId($musteriId)
            ->setSifre($sifre);
    }
    /**
     * Get dongu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InputDongu[]|null
     */
    public function getDongu()
    {
        return isset($this->dongu) ? $this->dongu : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDongu method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDongu method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDonguForArrayConstraintsFromSetDongu(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inputDonguItem) {
            // validation for constraint: itemType
            if (!$inputDonguItem instanceof \StructType\InputDongu) {
                $invalidValues[] = is_object($inputDonguItem) ? get_class($inputDonguItem) : sprintf('%s(%s)', gettype($inputDonguItem), var_export($inputDonguItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The dongu property can only contain items of type \StructType\InputDongu, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set dongu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InputDongu[] $dongu
     * @return \StructType\Input
     */
    public function setDongu(array $dongu = array())
    {
        // validation for constraint: array
        if ('' !== ($donguArrayErrorMessage = self::validateDonguForArrayConstraintsFromSetDongu($dongu))) {
            throw new \InvalidArgumentException($donguArrayErrorMessage, __LINE__);
        }
        if (is_null($dongu) || (is_array($dongu) && empty($dongu))) {
            unset($this->dongu);
        } else {
            $this->dongu = $dongu;
        }
        return $this;
    }
    /**
     * Add item to dongu value
     * @throws \InvalidArgumentException
     * @param \StructType\InputDongu $item
     * @return \StructType\Input
     */
    public function addToDongu(\StructType\InputDongu $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InputDongu) {
            throw new \InvalidArgumentException(sprintf('The dongu property can only contain items of type \StructType\InputDongu, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->dongu[] = $item;
        return $this;
    }
    /**
     * Get dosyaAdi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDosyaAdi()
    {
        return isset($this->dosyaAdi) ? $this->dosyaAdi : null;
    }
    /**
     * Set dosyaAdi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dosyaAdi
     * @return \StructType\Input
     */
    public function setDosyaAdi($dosyaAdi = null)
    {
        // validation for constraint: string
        if (!is_null($dosyaAdi) && !is_string($dosyaAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dosyaAdi, true), gettype($dosyaAdi)), __LINE__);
        }
        if (is_null($dosyaAdi) || (is_array($dosyaAdi) && empty($dosyaAdi))) {
            unset($this->dosyaAdi);
        } else {
            $this->dosyaAdi = $dosyaAdi;
        }
        return $this;
    }
    /**
     * Get gonderiTip value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGonderiTip()
    {
        return isset($this->gonderiTip) ? $this->gonderiTip : null;
    }
    /**
     * Set gonderiTip value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $gonderiTip
     * @return \StructType\Input
     */
    public function setGonderiTip($gonderiTip = null)
    {
        // validation for constraint: string
        if (!is_null($gonderiTip) && !is_string($gonderiTip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gonderiTip, true), gettype($gonderiTip)), __LINE__);
        }
        if (is_null($gonderiTip) || (is_array($gonderiTip) && empty($gonderiTip))) {
            unset($this->gonderiTip);
        } else {
            $this->gonderiTip = $gonderiTip;
        }
        return $this;
    }
    /**
     * Get gonderiTur value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGonderiTur()
    {
        return isset($this->gonderiTur) ? $this->gonderiTur : null;
    }
    /**
     * Set gonderiTur value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $gonderiTur
     * @return \StructType\Input
     */
    public function setGonderiTur($gonderiTur = null)
    {
        // validation for constraint: string
        if (!is_null($gonderiTur) && !is_string($gonderiTur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gonderiTur, true), gettype($gonderiTur)), __LINE__);
        }
        if (is_null($gonderiTur) || (is_array($gonderiTur) && empty($gonderiTur))) {
            unset($this->gonderiTur);
        } else {
            $this->gonderiTur = $gonderiTur;
        }
        return $this;
    }
    /**
     * Get kullanici value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKullanici()
    {
        return isset($this->kullanici) ? $this->kullanici : null;
    }
    /**
     * Set kullanici value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kullanici
     * @return \StructType\Input
     */
    public function setKullanici($kullanici = null)
    {
        // validation for constraint: string
        if (!is_null($kullanici) && !is_string($kullanici)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullanici, true), gettype($kullanici)), __LINE__);
        }
        if (is_null($kullanici) || (is_array($kullanici) && empty($kullanici))) {
            unset($this->kullanici);
        } else {
            $this->kullanici = $kullanici;
        }
        return $this;
    }
    /**
     * Get musteriId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getMusteriId()
    {
        return isset($this->musteriId) ? $this->musteriId : null;
    }
    /**
     * Set musteriId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $musteriId
     * @return \StructType\Input
     */
    public function setMusteriId($musteriId = null)
    {
        // validation for constraint: int
        if (!is_null($musteriId) && !(is_int($musteriId) || ctype_digit($musteriId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($musteriId, true), gettype($musteriId)), __LINE__);
        }
        if (is_null($musteriId) || (is_array($musteriId) && empty($musteriId))) {
            unset($this->musteriId);
        } else {
            $this->musteriId = $musteriId;
        }
        return $this;
    }
    /**
     * Get sifre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSifre()
    {
        return isset($this->sifre) ? $this->sifre : null;
    }
    /**
     * Set sifre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sifre
     * @return \StructType\Input
     */
    public function setSifre($sifre = null)
    {
        // validation for constraint: string
        if (!is_null($sifre) && !is_string($sifre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sifre, true), gettype($sifre)), __LINE__);
        }
        if (is_null($sifre) || (is_array($sifre) && empty($sifre))) {
            unset($this->sifre);
        } else {
            $this->sifre = $sifre;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Input
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
