<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Output StructType
 * @subpackage Structs
 */
class Output extends AbstractStructBase
{
    /**
     * The RCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $RCode;
    /**
     * The aciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $aciklama;
    /**
     * The sonuc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $sonuc;
    /**
     * The sqlCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sqlCode;
    /**
     * Constructor method for Output
     * @uses Output::setRCode()
     * @uses Output::setAciklama()
     * @uses Output::setSonuc()
     * @uses Output::setSqlCode()
     * @param int $rCode
     * @param string $aciklama
     * @param bool $sonuc
     * @param int $sqlCode
     */
    public function __construct($rCode = null, $aciklama = null, $sonuc = null, $sqlCode = null)
    {
        $this
            ->setRCode($rCode)
            ->setAciklama($aciklama)
            ->setSonuc($sonuc)
            ->setSqlCode($sqlCode);
    }
    /**
     * Get RCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getRCode()
    {
        return isset($this->RCode) ? $this->RCode : null;
    }
    /**
     * Set RCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $rCode
     * @return \StructType\Output
     */
    public function setRCode($rCode = null)
    {
        // validation for constraint: int
        if (!is_null($rCode) && !(is_int($rCode) || ctype_digit($rCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rCode, true), gettype($rCode)), __LINE__);
        }
        if (is_null($rCode) || (is_array($rCode) && empty($rCode))) {
            unset($this->RCode);
        } else {
            $this->RCode = $rCode;
        }
        return $this;
    }
    /**
     * Get aciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAciklama()
    {
        return isset($this->aciklama) ? $this->aciklama : null;
    }
    /**
     * Set aciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $aciklama
     * @return \StructType\Output
     */
    public function setAciklama($aciklama = null)
    {
        // validation for constraint: string
        if (!is_null($aciklama) && !is_string($aciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aciklama, true), gettype($aciklama)), __LINE__);
        }
        if (is_null($aciklama) || (is_array($aciklama) && empty($aciklama))) {
            unset($this->aciklama);
        } else {
            $this->aciklama = $aciklama;
        }
        return $this;
    }
    /**
     * Get sonuc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSonuc()
    {
        return isset($this->sonuc) ? $this->sonuc : null;
    }
    /**
     * Set sonuc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $sonuc
     * @return \StructType\Output
     */
    public function setSonuc($sonuc = null)
    {
        // validation for constraint: boolean
        if (!is_null($sonuc) && !is_bool($sonuc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sonuc, true), gettype($sonuc)), __LINE__);
        }
        if (is_null($sonuc) || (is_array($sonuc) && empty($sonuc))) {
            unset($this->sonuc);
        } else {
            $this->sonuc = $sonuc;
        }
        return $this;
    }
    /**
     * Get sqlCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSqlCode()
    {
        return isset($this->sqlCode) ? $this->sqlCode : null;
    }
    /**
     * Set sqlCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sqlCode
     * @return \StructType\Output
     */
    public function setSqlCode($sqlCode = null)
    {
        // validation for constraint: int
        if (!is_null($sqlCode) && !(is_int($sqlCode) || ctype_digit($sqlCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sqlCode, true), gettype($sqlCode)), __LINE__);
        }
        if (is_null($sqlCode) || (is_array($sqlCode) && empty($sqlCode))) {
            unset($this->sqlCode);
        } else {
            $this->sqlCode = $sqlCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Output
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
