<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutputIstek StructType
 * @subpackage Structs
 */
class OutputIstek extends AbstractStructBase
{
    /**
     * The siparisId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $siparisId;
    /**
     * The sonucAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sonucAciklama;
    /**
     * The sonucKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sonucKodu;
    /**
     * Constructor method for OutputIstek
     * @uses OutputIstek::setSiparisId()
     * @uses OutputIstek::setSonucAciklama()
     * @uses OutputIstek::setSonucKodu()
     * @param int $siparisId
     * @param string $sonucAciklama
     * @param int $sonucKodu
     */
    public function __construct($siparisId = null, $sonucAciklama = null, $sonucKodu = null)
    {
        $this
            ->setSiparisId($siparisId)
            ->setSonucAciklama($sonucAciklama)
            ->setSonucKodu($sonucKodu);
    }
    /**
     * Get siparisId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSiparisId()
    {
        return isset($this->siparisId) ? $this->siparisId : null;
    }
    /**
     * Set siparisId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $siparisId
     * @return \StructType\OutputIstek
     */
    public function setSiparisId($siparisId = null)
    {
        // validation for constraint: int
        if (!is_null($siparisId) && !(is_int($siparisId) || ctype_digit($siparisId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($siparisId, true), gettype($siparisId)), __LINE__);
        }
        if (is_null($siparisId) || (is_array($siparisId) && empty($siparisId))) {
            unset($this->siparisId);
        } else {
            $this->siparisId = $siparisId;
        }
        return $this;
    }
    /**
     * Get sonucAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSonucAciklama()
    {
        return isset($this->sonucAciklama) ? $this->sonucAciklama : null;
    }
    /**
     * Set sonucAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sonucAciklama
     * @return \StructType\OutputIstek
     */
    public function setSonucAciklama($sonucAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($sonucAciklama) && !is_string($sonucAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucAciklama, true), gettype($sonucAciklama)), __LINE__);
        }
        if (is_null($sonucAciklama) || (is_array($sonucAciklama) && empty($sonucAciklama))) {
            unset($this->sonucAciklama);
        } else {
            $this->sonucAciklama = $sonucAciklama;
        }
        return $this;
    }
    /**
     * Get sonucKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSonucKodu()
    {
        return isset($this->sonucKodu) ? $this->sonucKodu : null;
    }
    /**
     * Set sonucKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sonucKodu
     * @return \StructType\OutputIstek
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        if (is_null($sonucKodu) || (is_array($sonucKodu) && empty($sonucKodu))) {
            unset($this->sonucKodu);
        } else {
            $this->sonucKodu = $sonucKodu;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutputIstek
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
